/**************************************************************
 *         _____    __                       _____            *
 *        /  _  \  |  |    ____  ___  ___   /  |  |           *
 *       /  /_\  \ |  |  _/ __ \ \  \/  /  /   |  |_          *
 *      /    |    \|  |__\  ___/  >    <  /    ^   /          *
 *      \____|__  /|____/ \___  >/__/\_ \ \____   |           *
 *              \/            \/       \/      |__|           *
 *                                                            *
 **************************************************************
 *    (c) Free Lunch Design 2003                              *
 *    Written by Johan Peitz                                  *
 *    http://www.freelunchdesign.com                          *
 **************************************************************
 *    This source code is released under the The GNU          *
 *    General Public License (GPL). Please refer to the       *
 *    document license.txt in the source directory or         *
 *    http://www.gnu.org for license information.             *
 **************************************************************/
 

#include <allegro.h>
#include "joystick.h"

// For the GP2X (or any joystick-only device)
int _joypressed(int reset)
{
  static int pressed = 0;
  int ret;
  int stick,button;
  int pressed_now = 0;

  if (reset) { pressed = 0; return; }
  
  poll_joystick();

  for (stick = 0; stick < num_joysticks; ++stick)
  {
    for (button = 0; button < joy[stick].num_buttons; ++button)
    {
      if (joy[stick].button[button].b)
      {
	pressed_now = 1;
	break;
      }
    }
    if (pressed_now) break;
  }

  ret = (pressed_now && !pressed);
  pressed = pressed_now;
  return ret;
}

int joypressed()
{
  return _joypressed(0);
}

void clear_joybuf()
{
  int stick, button;
  for (stick = 0; stick < num_joysticks; ++stick)
  {
    for (button = 0; button < joy[stick].num_buttons; ++button)
    {
      joy[stick].button[button].b = 0;
    }
  }
  _joypressed(1);
}
